package cas;

import java.util.Random;

public class MainStack {
	static final ConcurrentStack<Integer> stack = new ConcurrentStack<Integer>();
	static final Random random = new Random();
	public static void main(String[] args)
	{
		final int iters = 10;
		Thread one = new Thread(new Runnable(){
			public void run() {
				for(int i=0; i<iters; i++){
					if(random.nextInt(1000) > 450)Thread.yield();
					stack.push(i);
					System.out.println("thread 1: push " + i);
				}
				if(random.nextInt(1000) > 450)Thread.yield();
				for(int i=0; i<iters; i++){
					if(random.nextInt(1000) > 450)Thread.yield();
					Integer intObj = stack.pop();
					if(intObj == null)
						System.out.println("thread 1: pop null");
					else {
						int j = intObj;
						System.out.println("thread 1: pop " + j);
					}
				}
			}
		}
		);
		Thread two = new Thread(new Runnable(){
			public void run() {
				for(int i=100; i<iters+100; i++){
					stack.push(i);
					if(random.nextInt(1000) > 450)Thread.yield();
					System.out.println("thread 2: push " + i);
				}
				if(random.nextInt(1000) > 450)Thread.yield();
				for(int i=0; i<iters; i++){
					if(random.nextInt(1000) > 450)Thread.yield();
					Integer intObj = stack.pop();
					if(intObj == null)
						System.out.println("thread 2: pop null");
					else {
						int j = intObj;
						System.out.println("thread 2: pop " + j);
					}
				}
			}
		}
		);
		one.start(); two.start();
	}
}
